﻿var xBackCallRun = (function (_super) {
    __extends(xBackCallRun, _super);
    function xBackCallRun() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    
    xBackCallRun.prototype.execute = function () {
        // Get settings
        var commandSettings = this.CommandParam;
        var backFun = this.evaluateFormula(commandSettings.BackFun);
        var parameter1 = this.evaluateFormula(commandSettings.Parameter1);
        var parameter2 = this.evaluateFormula(commandSettings.Parameter2);
        var parameter3 = this.evaluateFormula(commandSettings.Parameter3);
        var parameter4 = this.evaluateFormula(commandSettings.Parameter4);
        var defaultFun = commandSettings.DefaultFun;

       
        


        switch (defaultFun) {
            case 0:
                this.AddCallBackFun(backFun, parameter1, parameter2, parameter3, parameter4)
                break;
            case 1:
                this.AddCallBackFun("xBackCallRun.prototype.JsonReplaceTable", parameter1, parameter2, parameter3, parameter4)                
                break;
            case 2:
                this.AddCallBackFun("xBackCallRun.prototype.JsonAddTable", parameter1, parameter2, parameter3, parameter4)
                break;
            case 3:
                this.AddCallBackFun("xBackCallRun.prototype.JsonReplaceTableCurrentRow", parameter1, parameter2, parameter3, parameter4)
                break;
            case 4:
                this.AddCallBackFun("xBackCallRun.prototype.ReplaceCurrentPageCells", parameter1, parameter2, parameter3, parameter4)
                break;
            case 5:
                this.AddCallBackFun("xBackCallRun.prototype.XTableRefresh", parameter1, parameter2, parameter3, parameter4)
                break;
            default:
                alert("非法操作......for xTools!");
        }


    };
    return xBackCallRun;
}(Forguncy.CommandBase));

xBackCallRun.prototype.AddCallBackFun = function (funname, arg1, arg2, arg3, arg4) {
    var pageName = Forguncy.Page.getPageName();
    var nowobj = xTools.args.find(xx => xx.pagename === pageName);
    for (var e in nowobj) {
        if (e != "pagename" && e != "callbacks") {
            delete nowobj[e];
        }
    }
    nowobj.callbacks.push(funname + "('" + arg1 + "','" + arg2 + "','" + arg3 + "','" + arg4 + "')");
};

xBackCallRun.prototype.JsonReplaceTable = function (tableName, key, excludeColumns) {
    var value = this.Getarg(key);
    if (value == null) {
        return;
    }
    if (typeof value != 'object') {
        value = JSON.parse(value);
    }
    if (excludeColumns != null) {
        let keys = Object.keys(value[0]);
        for (let i = 0; i < keys.length; i++) {
            let ele = keys[i];
            if (excludeColumns.includes(ele)) {
                for (var j = 0; j < value.length; j++) {
                    delete value[j][ele]
                }
            }
        }
    } 

    let xOry = false;//判断是否为XTableS表格
    //得到当前页表对象
    if (window.xTable != undefined && window.xTable.Tables != undefined) {
        let xtable = window.xTable.Tables.find(obj => obj.pagename == Forguncy.Page.getPageName() && obj.tablename == tableName)
        if (xtable) {
            let rowsCount = xtable.tableobject.xhelp.GetTableRowsCount();
            xtable.tableobject.xhelp.InsertRows(value, rowsCount);
            xOry = true;
        }
    }
    if (xOry == false) {
        value = JSON.stringify(value);
        this.JsonToTable(tableName, value, excludeColumns);
    }
}

xBackCallRun.prototype.JsonAddTable = function (tableName, key, excludeColumns) { 
    var value = this.Getarg(key);
    if (value == null) {
        return;
    }
    if (typeof value != 'object') {
        value = JSON.parse(value);
    }

    if (excludeColumns != null) {
        let keys = Object.keys(value[0]);
        for (let i = 0; i < keys.length; i++) {
            let ele = keys[i];
            if (excludeColumns.includes(ele)) {
                for (var j = 0; j < value.length; j++) {
                    delete value[j][ele]
                }
            }
        }
    } 

    let xOry = false;//判断是否为XTableS表格
    //得到当前页表对象
    if (window.xTable!=undefined && window.xTable.Tables!=undefined) {
        let xtable = window.xTable.Tables.find(obj => obj.pagename == Forguncy.Page.getPageName() && obj.tablename == tableName)
        if (xtable) {
            let rowsCount = xtable.tableobject.xhelp.GetTableRowsCount();
            xtable.tableobject.xhelp.InsertRows(value, rowsCount);
            xOry = true;
        } 
    }
    if (xOry == false) {
        value = JSON.stringify(value);
        this.AddJsonToTable(tableName, value, excludeColumns);
    }

}

xBackCallRun.prototype.JsonReplaceTableCurrentRow = function (tableName, key, excludeColumns) {
    var value = this.Getarg(key);
    if (value == null) {
        return;
    }
    if (typeof value != 'object') {
        value = JSON.parse(value);
    }
    if (excludeColumns != null) {
        let keys = Object.keys(value[0]);
        for (let i = 0; i < keys.length; i++) {
            let ele = keys[i];
            if (excludeColumns.includes(ele)) {
                for (var j = 0; j < value.length; j++) {
                    delete value[j][ele]
                }
            }
        }
    } 



    let xOry = false;//判断是否为XTableS表格
    //得到当前页表对象
    if (window.xTable != undefined && window.xTable.Tables != undefined) {
        let xtable = window.xTable.Tables.find(obj => obj.pagename == Forguncy.Page.getPageName() && obj.tablename == tableName)
        if (xtable) {
            let rowsCount = xtable.tableobject.xhelp.GetTableRowsCount();
            xtable.tableobject.xhelp.ReplaceRows(value, rowsCount);
            xOry = true;
        }
    }
    if (xOry == false) {
        value = JSON.stringify(value);
        this.JsonReplaceRow(tableName, value, excludeColumns);
    }
}

xBackCallRun.prototype.ReplaceCurrentPageCells = function (key) {
    var value = this.Getarg(key);
    if (value == null) {
        return;
    }

    var rowArrs = (JSON.parse(value, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));

    for (var index = 0; index < rowArrs.length; index++) {
        var item = rowArrs[index];

        for (var i = 0; i < Object.keys(item).length; i++) {
            //var cellLocation = this.getCellLocation(rowArrs[i].key);

            var key = Object.keys(item)[i];

            var flag = Forguncy.ForguncyData.pageInfo.pageElementManager.cells.getCellByName(key, !0, null)

            if (flag != null) {
                var cell = Forguncy.Page.getCell(key);
                cell.setValue(item[key]);
            }
        }

    }



}

xBackCallRun.prototype.XTableRefresh = function (tableName, colRefresh=false) {
    //得到当前页表对象
    let xtable = window.xTable.Tables.find(obj => obj.pagename == Forguncy.Page.getPageName() && obj.tablename == tableName)
    xtable.tableobject.xhelp.RefreshData(colRefresh);
    //顺带刷新相应控件数据
    let pageinfo = Forguncy.PageInfo.getCurrentPageInfo();
    let cells = pageinfo.pageElementManager.cells._cells;
    //el树形控件
    let treecontrols = cells.filter(item => {
        return item.cellType.constructor.name == "TreeCellType"
    })
    //el导航菜单
    let menucontrols = cells.filter(item => {
        return item.cellType.constructor.name == "NavMenuCellType"
    })
    if (treecontrols != null) {
        treecontrols.forEach(e => {
            e.cellType.reload();
        })
    }
    if (menucontrols != null) {
        menucontrols.forEach(e => {
            e.cellType.reload();
        })
    }
}



xBackCallRun.prototype.Getarg= function (key) {
    var pageName = Forguncy.Page.getPageName();
    var childrenobj = xTools.args.find(xx => xx.pagename === pageName);
    var value = childrenobj[key];
    return value;
}

xBackCallRun.prototype.JsonReplaceRow = function (tableName, jsonStr, excludeColumns) {
    var rows = (JSON.parse(jsonStr, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));
    var row = rows[0];

    if (excludeColumns != null) {
        let keys = Object.keys(row);
        for (let i = 0; i < keys.length; i++) {
            let ele = keys[i];
            if (excludeColumns.includes(ele)) {
                delete row[ele]
            }
        }
    }


    var listview = Forguncy.Page.getListView(tableName);
    var index = listview.getSelectedRowIndex();
    if (Array.isArray(index)) {
        //为选择了表格多行数组，不执行下面代码
        console.log("xTools Error:表格选择了多行记录，不执行以下代码！");
        return;
    }
    var colnames = this.GetColumnNameReal(tableName);
    for (const key in row) {
        if (Object.hasOwnProperty.call(row, key)) {
            const e = row[key];
            if (colnames.indexOf(key) >= 0) {
                listview.setValue(index, key, e);
            }
        }
    }
    return;
}

xBackCallRun.prototype.JsonToTable = function (tableName, jsonStr, excludeColumns) {
    this.DeleteTableAllRow(tableName);
    this.AddJsonToTable(tableName, jsonStr, excludeColumns);
    return;
}

xBackCallRun.prototype.DeleteTableAllRow = function (tableName, jsonStr) {
    var listview = Forguncy.Page.getListView(tableName);
    var RowCount = Forguncy.Page.getListView(tableName).getRowCount();
    for (var rowCount = 0; rowCount < RowCount; rowCount++) {
        listview.deleteRow(0);
    }
    return;
}

xBackCallRun.prototype.AddJsonToTable = function (tableName, jsonStr, excludeColumns) {
    var listview = Forguncy.Page.getListView(tableName);
    var spread = listview.getControl();
    var ColumnNames = this.GetColumnNameReal(tableName);
    var rowArrs = (JSON.parse(jsonStr, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));

    if (excludeColumns != null) {
        let keys = Object.keys(rowArrs[0]);
        for (let i = 0; i < keys.length; i++) {
            let ele = keys[i];
            if (excludeColumns.includes(ele)) {
                for (var j = 0; j < rowArrs.length; j++) {
                    delete rowArrs[j][ele]
                }               
            }
        }
    } 



    for (let i = 0; i < rowArrs.length; i++) {
        var newrow = new Object();
        ColumnNames.forEach(e => {
            if (rowArrs[i][e] == null) {

            } else {
                newrow[e] = rowArrs[i][e];
            }
        });
        listview.addNewRow(newrow, true);
    }
    return;
}


xBackCallRun.prototype.GetColumnNameReal = function (tableName) {
    var result = new Array();
    var listview = Forguncy.Page.getListView(tableName);
    var arrobj = new Array();
    listview._grid.listviewData.columnDataInfos.forEach(e => {
        if (e.columnName != null) {
            var obj = new Object();
            obj.sort = e.bindingInfoIndex;
            obj.txt = e.columnName;
            arrobj.push(obj);
        }
    });
    let sortkeys = Object.keys(arrobj).sort(((a, b) => {
        return arrobj[a].sort - arrobj[b].sort;
    }))
    //for (const sortindex in sortkeys) {
    //    result.push(arrobj[sortkeys[sortindex]].txt);
    //}

    for (var i = 0; i < sortkeys.length; i++) {
        var e = sortkeys[i];
        result.push(arrobj[e].txt);
    }
    return result;
};


// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("xTools.Commands.xBackCallRun, xTools", xBackCallRun);