﻿var xCellsToRow = (function (_super) {
    __extends(xCellsToRow, _super);
    function xCellsToRow() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    xCellsToRow.prototype.execute = function () {
        // Get settings
        var self = this;
        var commandSettings = this.CommandParam;

        var defaultFun = commandSettings.DefaultFun;
        var tableName = commandSettings.TableName;
        var index = this.evaluateFormula(commandSettings.Index);
        var jsonstrtemp = this.evaluateFormula(commandSettings.JsonString);

        var excludeColumns = arrayParam(commandSettings.ExcludeColumns);
        //if (typeof commandSettings.ExcludeColumns == "undefined") {
        //    if (commandSettings.ExcludeColumns.indexOf("=") == 0) {
        //        if (commandSettings.ExcludeColumns.includes(",")) {
        //            excludeColumns = commandSettings.ExcludeColumns.slice(1).split(",");
        //        } else {
        //            excludeColumns = this.evaluateFormula(commandSettings.ExcludeColumns);
        //        }
        //    } else {
        //        excludeColumns = commandSettings.ExcludeColumns.split(",");
        //    }
        //}


        function arrayParam(param) {
            var result=null;
            if (typeof param != "undefined") {
                if (param.indexOf("=") == 0) {
                    if (param.includes(",")) {
                        result = param.slice(1).split(",");
                    } else {
                        result = self.evaluateFormula(param);
                    }
                } else {
                    result = param.split(",");
                }
            }
            return result;
        }


        var jsonstr = jsonstrtemp;
        if (excludeColumns != null) {
            var jsonobj = (JSON.parse(jsonstr, function (k, v) {
                if (v == null) {
                    v = "";
                }
                return v;
            }));
            let keys = Object.keys(jsonobj[0]);
            for (let i = 0; i < keys.length; i++) {
                let ele = keys[i];
                if (excludeColumns.includes(ele)) {
                    delete jsonobj[0][ele]
                }
            }
            jsonstr = JSON.stringify(jsonobj);
        } 

    


        switch (defaultFun) {
            case 0:
                this.JsonReplaceRow(tableName, jsonstr);
                break;
            case 1:
                this.AddJsonToTable(tableName, jsonstr);
                break;
            case 2:
                this.JsonReplaceIndexRow(tableName, jsonstr,index);
                break;          
            default:
                alert("非法操作......for xTools!");
        }


    };
    return xCellsToRow;
}(Forguncy.CommandBase));


xCellsToRow.prototype.JsonReplaceIndexRow = function (tableName, jsonStr,index) {
    var rows = (JSON.parse(jsonStr, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));
    var row = rows[0];
    var listview = Forguncy.Page.getListView(tableName);
    
    if (index > listview.getRowCount() - 1) {
        console.log("xTools Error:索引行大于已有行数，请核实！");
        return;
    }
    var colnames = this.GetColumnNameReal(tableName);
    for (const key in row) {
        if (Object.hasOwnProperty.call(row, key)) {
            const e = row[key];
            if (colnames.indexOf(key) >= 0) {
                listview.setValue(index, key, e);
            }
        }
    }
    return;
}


xCellsToRow.prototype.JsonReplaceRow = function (tableName, jsonStr) {
    var rows = (JSON.parse(jsonStr, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));
    var row = rows[0];
    var listview = Forguncy.Page.getListView(tableName);
    var index = listview.getSelectedRowIndex();
    if (Array.isArray(index)) {
        //为选择了表格多行数组，不执行下面代码
        console.log("xTools Error:表格选择了多行记录，不执行以下代码！");
        return;
    }
    var colnames = this.GetColumnNameReal(tableName);
    for (const key in row) {
        if (Object.hasOwnProperty.call(row, key)) {
            const e = row[key];
            if (colnames.indexOf(key) > 0) {
                listview.setValue(index, key, e);
            }
        }
    }
    return;
}

xCellsToRow.prototype.AddJsonToTable = function (tableName, jsonStr) {
    var listview = Forguncy.Page.getListView(tableName);
    var spread = listview.getControl();
    var ColumnNames = this.GetColumnNameReal(tableName);
    var rowArrs = (JSON.parse(jsonStr, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));
    for (let i = 0; i < rowArrs.length; i++) {
        var newrow = new Object();
        ColumnNames.forEach(e => {
            if (rowArrs[i][e] == null) {

            } else {
                newrow[e] = rowArrs[i][e];
            }
        });
        listview.addNewRow(newrow, true);
    }
    return;
}

xCellsToRow.prototype.GetColumnNameReal = function (tableName) {
    var result = new Array();
    var listview = Forguncy.Page.getListView(tableName);
    var arrobj = new Array();
    listview._grid.listviewData.columnDataInfos.forEach(e => {
        if (e.columnName != null) {
            var obj = new Object();
            obj.sort = e.bindingInfoIndex;
            obj.txt = e.columnName;
            arrobj.push(obj);
        }
    });
    let sortkeys = Object.keys(arrobj).sort(((a, b) => {
        return arrobj[a].sort - arrobj[b].sort;
    }))

    for (var i = 0; i < sortkeys.length; i++) {
        var e = sortkeys[i];
        result.push(arrobj[e].txt);
    }
    return result;
};


// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("xTools.Commands.xCellsToRow, xTools", xCellsToRow);