﻿var xJsonToTable = (function (_super) {
    __extends(xJsonToTable, _super);
    function xJsonToTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    

    xJsonToTable.prototype.execute = function () {
        // Get settings
        var commandSettings = this.CommandParam;
        var jsonData = this.evaluateFormula(commandSettings.JsonData);
        var tableName = commandSettings.TableName;
        var replaceTable = commandSettings.ReplaceTable;


        if (replaceTable) {
            this.DeleteTableAllRow(tableName);
            this.AddJsonToTable(tableName, jsonData);
            return;
        } else {
            this.AddJsonToTable(tableName, jsonData);
            return;
        }
    };
    return xJsonToTable;
}(Forguncy.CommandBase));

xJsonToTable.prototype.DeleteTableAllRow = function (tableName) {
    var listview = Forguncy.Page.getListView(tableName);
    var RowCount = Forguncy.Page.getListView(tableName).getRowCount();
    for (var rowCount = 0; rowCount < RowCount; rowCount++) {
        listview.deleteRow(0);
    }
    return;
};

xJsonToTable.prototype.AddJsonToTable = function (tableName, jsonStr) {
    var listview = Forguncy.Page.getListView(tableName);
    var spread = listview.getControl();
    var ColumnNames = this.GetColumnNameReal(tableName);
    var rowArrs = (JSON.parse(jsonStr, function (k, v) {
        if (v == null) {
            v = "";
        }
        return v;
    }));
    for (let i = 0; i < rowArrs.length; i++) {
        var newrow = new Object();
        ColumnNames.forEach(e => {
            if (rowArrs[i][e] == null) {

            } else {
                newrow[e] = rowArrs[i][e];
            }
        });
        listview.addNewRow(newrow, true);
    }
    return;
};


xJsonToTable.prototype.GetColumnNameReal = function (tableName) {
    var result = new Array();

    var listview = Forguncy.Page.getListView(tableName);
    var arrobj = new Array();
    listview._grid.listviewData.columnDataInfos.forEach(e => {
        if (e.columnName != null) {
            var obj = new Object();
            obj.sort = e.bindingInfoIndex;
            obj.txt = e.columnName;
            arrobj.push(obj);
        }
    });
    let sortkeys = Object.keys(arrobj).sort(((a, b) => {
        return arrobj[a].sort - arrobj[b].sort;
    }))

    for (let [key, value] of Object.entries(sortkeys)) {
        result.push(arrobj[sortkeys[key]].txt);
    }



    //for (const sortindex in sortkeys) {
    //    if (Object.prototype.hasOwnProperty.call(sortkeys, sortindex)) {           
    //        console.log(arrobj[sortkeys[sortindex]].txt);            
    //    }       
    //}

    return result;
};



// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("xTools.Commands.xJsonToTable, xTools", xJsonToTable);

