﻿var xTableToJson = (function (_super) {
    __extends(xTableToJson, _super);
    function xTableToJson() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    xTableToJson.prototype.execute = function () {
        // Get settings
        var commandSettings = this.CommandParam;
        var tableName = commandSettings.TableName;
        var colArray = typeof commandSettings.ColArray == "undefined" || this.evaluateFormula(commandSettings.ColArray) == null ? "" : this.evaluateFormula(commandSettings.ColArray).split(",");

        var comp = typeof commandSettings.Comp == "undefined" || this.evaluateFormula(commandSettings.Comp) == null ? "" : this.evaluateFormula(commandSettings.Comp).split(",")[0];


        var tableData = this.GetTableAllRowReal(tableName, colArray, comp);

        var result = JSON.stringify(tableData, null, " ");
        if (commandSettings.ToParameter) {
            Forguncy.CommandHelper.setVariableValue(this.evaluateFormula(commandSettings.ToParameter), result);
        }

    };
    return xTableToJson;
}(Forguncy.CommandBase));

xTableToJson.prototype.GetTableAllRowReal = function (tableName, colArray, comp) {
    var result = new Array();
    var RowCount = Forguncy.Page.getListView(tableName).getRowCount();
    var result = this.GetTableTogetherRowReal(tableName, 0, RowCount, colArray, comp);
    return result;
};

xTableToJson.prototype.GetColumnNameReal = function (tableName) {
    var result = new Array();

    var listview = Forguncy.Page.getListView(tableName);
    var arrobj = new Array();
    listview._grid.listviewData.columnDataInfos.forEach(e => {
        if (e.columnName != null) {
            var obj = new Object();
            obj.sort = e.bindingInfoIndex;
            obj.txt = e.columnName;
            arrobj.push(obj);
        }
    });
    let sortkeys = Object.keys(arrobj).sort(((a, b) => {
        return arrobj[a].sort - arrobj[b].sort;
    }))
    for (var i = 0; i < sortkeys.length; i++) {
        var e = sortkeys[i];
        result.push(arrobj[e].txt);
    }

    return result;
};

xTableToJson.prototype.GetTableTogetherRowReal = function (tableName, start, end, colArray, comp) {
    var result = new Array();
    var listview = Forguncy.Page.getListView(tableName);
    var ColumnNames = this.GetColumnNameReal(tableName);

    var comps;
    if (comp.split("=").length != 2) { } else {
        comps = comp.split("=");
        comps[2] = comps[1]
        comps[1] = "==";
        
    }
    if (comp.split(">").length != 2) { } else {
        comps = comp.split(">");
        comps[2] = comps[1]
        comps[1] = ">";
    }
    if (comp.split("<").length != 2) { } else {
        comps = comp.split("<");
        comps[2] = comps[1]
        comps[1] = "<";
    }
    if (comp.split("!=").length != 2) { } else {
        comps = comp.split("!=");
        comps[2] = comps[1]
        comps[1] = "!=";
    }

    for (i = start; i < start + end; i++) {
        var row = new Object();
        for (j = 0; j < ColumnNames.length; j++) {            

            var val;
            if (colArray != "") {
                if (isInArray(colArray, ColumnNames[j])) {
                    var cName = ColumnNames[j];
                    if (listview.getValue(i, cName) == null) {
                        val = "";
                    } else {
                        val = listview.getValue(i, cName);
                    }
                }
            } else {
                var cName = ColumnNames[j];
                if (listview.getValue(i, cName) == null) {
                    val = "";
                } else {
                    val = listview.getValue(i, cName);
                }
            }
            row.length
            row[cName] = val;
        }

        if (comps == null) {
            result.push(row);
        } else {
            var regPos = /^\d+(\.\d+)?$/;
            var regNeg = /^(-(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*)))$/;
            if (regPos.test(comps[0]) || regNeg.test(comps[0])) {
                if (eval(row[comps[0]] + comps[1])) {
                    result.push(row);
                }
            } else {
                if (eval("'" + row[comps[0]] + "'" + comps[1]+"'" + comps[2] + "'")) {
                    result.push(row);
                }
            }
        }
   


    }




    return result;
};

function isInArray(arr, value) {
    for (var i = 0; i < arr.length; i++) {
        if (value === arr[i]) {
            return true;
        }
    }
    return false;
}


// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("xTools.Commands.xTableToJson, xTools", xTableToJson);